# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://github.com/mobsf/mobsfscan/blob/main/mobsfscan/rules/patterns/ios/swift/swift_rules.yaml
# hash: e29e85c3
# yamllint enable
---
rules:
  - id: rules_lgpl_swift_other_rule-ios-dtls1-used
    patterns:
      - pattern:
          $Y.TLSMinimumSupportedProtocolVersion
      - pattern-inside: |
          ...
          $X = "tls_protocol_version_t.DTLSv10"
          ...
    message: |
      DTLS 1.2 should be used. Detected old version - DTLS 1.0.
      DTLS (Datagram Transport Layer Security) 1.0 suffers from 
      various security vulnerabilities and weaknesses, as it is 
      an outdated and less secure protocol compared to newer 
      versions such as DTLS 1.2 or 1.3.
      
      Here's an example of how to use DTLS 1.2:
      ```
      import Network
  
      // Create a NWConnection instance with DTLS 1.2
      let connection = NWConnection(host: NWEndpoint.Host("example.com"), port: NWEndpoint.Port("443"), using: .dtls)
      
      // Start the connection
      connection.start(queue: .main)
      
      // Handle connection state changes
      connection.stateUpdateHandler = { newState in
        switch newState {
        case .ready:
          print("Connection ready.")
        // Perform data transfer or other operations
        case .failed(let error):
          print("Connection failed with error: \(error)")
        default:
          break
        }
      }
      ```

    languages:
      - swift
    severity: WARNING
    metadata:
      cwe: "CWE-757"
      shortDescription: "Selection of less-secure algorithm during negotiation ('algorithm downgrade')"
      owasp:
        - "A6:2017-Security Misconfiguration"
        - "A5:2021-Security Misconfiguration"
      security-severity: MEDIUM